'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

exports['default'] = enableSentry;

function enableSentry(_ref) {
  var filename = _ref.filename;
  var components = _ref.components;
  var imports = _ref.imports;

  var _imports = _slicedToArray(imports, 1);

  var React = _imports[0];

  if (!React || !React.Component) {
    throw new Error('imports[0] for react-transform-sentry does not look like React.');
  }

  return function wrapToCatchErrors(ReactClass, componentId) {
    var wrapThisMethods = ['render', 'componentWillMount', 'componentDidMount', 'componentWillReceiveProps', 'shouldComponentUpdate', 'componentWillUpdate', 'componentDidUpdate', 'componentWillUnmount'];

    wrapThisMethods.forEach(function (m) {
      var originalMethod = ReactClass.prototype[m];
      if (!originalMethod) {
        return;
      }
      ReactClass.prototype[m] = function tryWrappedMethod() {
        try {
          return originalMethod.apply(this, arguments);
        } catch (err) {
          Raven.captureException(err, { extra: { component: ReactClass.name, method: m } });
          throw err;
        }
      };
    });

    return ReactClass;
  };
}

module.exports = exports['default'];